<div class="todo-card">
  <div class="todo-header" (click)="isCollapsed = !isCollapsed">
    <div class="header-text">
      To Do List
    </div>

    <div>
      <i *ngIf="!isCollapsed" class="fa fa-minus" aria-hidden="true"></i>
      <i *ngIf="isCollapsed" class="fa fa-plus" aria-hidden="true"></i>
    </div>
  </div>

  <!-- Collapsible Body -->
  <div id="collapseBasic" [collapse]="isCollapsed">
    <div class="todo-body">

      <!-- Tabs -->
      <tabset>
        <!-- Todo Tab -->
        <tab heading="Todo List" id="tab1">
          <!-- Add Todo -->
          <form class="add-todo" #todoForm="ngForm">
            <div class="mb-2">
              <input class="form-control input-sm" [(ngModel)]="todoInput" name="addTodoTitle" #addTodoTitle="ngModel"
                required>
              <div class="error-msg" *ngIf="addTodoTitle.invalid && submitted">
                Required.
              </div>
            </div>
            <div>
              <button class="btn btn-primary btn-sm ml-1" (click)="addTodo(todoForm)">Add</button>
            </div>
          </form>
          <!-- End Add Todo -->

          <!-- Todo List -->
          <div class="todo-list">
            <div *ngIf="todosLoading">
              Loading....
            </div>

            <div class="todo-item" *ngFor="let todo of todos | slice:0:5" (mouseenter)="showAction(todo)"
              (mouseleave)="hideAction()">

              <!-- Todo Title & Date -->
              <div class="todo-title-date">
                <form class="todo-form">
                  <input class="todo-checkbox" type="checkbox" [checked]="todo.completed ? true: false"
                    (click)="completeTodo(todo, $event)">

                  <div *ngIf="todoToEdit && todo.id === todoToEdit.id">
                    <textarea [(ngModel)]="todoToEdit.title" name="todoTitle" #todoTitle="ngModel" rows="4"
                      [disabled]="disabledValue" required></textarea>
                    <div class="error-msg" *ngIf="todoTitle.invalid">
                      Title is required.
                    </div>
                  </div>

                  <div *ngIf="(todoToEdit && todo.id != todoToEdit.id) || !todoToEdit">
                    <p class="todo-title" [ngStyle]="{'text-decoration': todo.completed ? 'line-through' : null}">
                      {{todo.title}}</p>
                    <p class="date-time">{{todo.date | date: 'mediumDate'}}</p>
                  </div>
                </form>
              </div>

              <!-- Action Buttons -->
              <div>
                <ng-container *ngIf="hoveredTodo && todo.id === hoveredTodo.id">
                  <ng-container *ngIf="!todoToEdit || (todoToEdit && todoToEdit.id != todo.id)">
                    <i *ngIf="!todo.completed" class="fas fa-pencil-alt mr-2" (click)="editTodo(todo)"
                      tooltip="Edit"></i>
                    <i class="fa fa-archive" aria-hidden="true" tooltip="Archive" (click)="openConfirmDialog(todo)"></i>
                  </ng-container>

                  <ng-container *ngIf="todoToEdit && todo.id === todoToEdit.id">
                    <i class="fa fa-save mr-2" (click)="updateTodo(todo)" tooltip="Save"></i>
                    <i class="fa fa-times" (click)="cancelUpdate()" tooltip="Cancel"></i>
                    <span class="ml-2" *ngIf="disableSaveAndCancelBtn">
                      <i class="fas fa-spinner fa-spin"></i>
                    </span>
                  </ng-container>
                </ng-container>
              </div>
              <!-- End of Action Buttons -->
            </div>

            <div *ngIf="!todosCount && !todosLoading">
              No results
            </div>
          </div>
          <!-- End Todo List  -->

          <div class="show-more" *ngIf="todos && todosCount > 5">
            <a (click)="openShowMoreModal(allTodoList)">Show More</a>
          </div>

        </tab>
        <!-- End Todo Tab -->

        <!-- Archive Tab -->
        <tab heading="Archive" (selectTab)="toggleArchivedTodo()">
          <app-archive [refreshArchiveList]="isTodoArchived" (restoreArchive)="getTodos()"></app-archive>
        </tab>
        <!-- End Archive Tab -->
      </tabset>
      <!-- End Tabs  -->

    </div>
  </div>
  <!-- End of Collapsible Body -->


  <!-- Show more Todo List Modal -->
  <ng-template #allTodoList>
    <div class="modal-header">
      <h4 class="modal-title pull-left">Todo List</h4>
      <button type="button" class="close pull-right" aria-label="Close" (click)="closeShowMoreModal()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="todo-item" *ngFor="let todo of todos | slice:5" (mouseenter)="showAction(todo)"
        (mouseleave)="hideAction()">

        <!-- Todo Title & Date -->
        <div class="todo-title-date">
          <form class="todo-form" [formGroup]="updateTodoForm">
            <input class="todo-checkbox" type="checkbox" [checked]="todo.completed ? true: false"
              (click)="completeTodo(todo, $event)">

            <div *ngIf="todoToEdit && todo.id === todoToEdit.id">
              <textarea formControlName="todoTitle" rows="4" required></textarea>
              <div class="error-msg" *ngIf="updateTodoForm.get('todoTitle').errors?.required">
                Title is required.
              </div>
            </div>

            <div *ngIf="(todoToEdit && todo.id != todoToEdit.id) || !todoToEdit">
              <p class="todo-title" [ngStyle]="{'text-decoration': todo.completed ? 'line-through' : null}">
                {{todo.title}}</p>
              <p class="date-time">{{todo.date | date: 'mediumDate'}}</p>
            </div>
          </form>
        </div>

        <!-- Action Buttons -->
        <div *ngIf="hoveredTodo && todo.id === hoveredTodo.id">
          <ng-container *ngIf="!todoToEdit || (todoToEdit && todoToEdit.id != todo.id)">
            <i *ngIf="!todo.completed" class="fas fa-pencil-alt mr-2" (click)="editTodo(todo)" tooltip="Edit"></i>
            <i class="fa fa-archive" aria-hidden="true" tooltip="Archive" (click)="openConfirmDialog(todo)"></i>
          </ng-container>

          <ng-container *ngIf="todoToEdit && todo.id === todoToEdit.id">
            <i class="fa fa-save mr-2" (click)="updateTodo(todo)" tooltip="Save"></i>
            <i class="fa fa-times" (click)="cancelUpdate()" tooltip="Cancel"></i>
            <span class="ml-2" *ngIf="disableSaveAndCancelBtn">
              <i class="fas fa-spinner fa-spin"></i>
            </span>
          </ng-container>
        </div>
        <!-- End of Action Buttons -->
      </div>
    </div>
  </ng-template>
  <!-- End of Show more Todo List Modal -->

</div>